<script lang="ts">
import Vue from 'vue';
import { UseLocalizedVideoSubtitles } from '~/mixins';

interface DropdownItem {
  title: string;
  video: { url: string; thumbnail: string };
  text: Array<string>;
}

interface ContentItem {
  title: string;
  id: string;
  dropdownItems: Array<DropdownItem>;
}

export default Vue.extend({
  name: 'AnalyticsInsightsShowcaseFaq',
  mixins: [UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      isModalOpen: false,
      selectedTab: 0,
      selectedItem: 0,
    };
  },
  computed: {
    returnSelectedTab(): ContentItem {
      return this.data.content_items[this.selectedTab];
    },
    renderText(): string {
      return this.data.content_items[this.selectedTab].dropdownItems[
        this.selectedItem
      ].text;
    },
  },
  methods: {
    selectTab(index: number): void {
      this.selectedTab = index;

      // Reset dropdown to first option
      this.selectedItem = 0;
    },
    selectItem(index: number): void {
      this.selectedItem = index;
    },
    openModal(): void {
      this.isModalOpen = true;

      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
  },
});
</script>
<template>
  <section
    class="slp-my-64 container"
    :class="{
      'container--purple-bg': data.dark_bg,
      'container--no-clip-path': isModalOpen,
    }"
  >
    <div class="controls">
      <div
        v-for="(tab, idx) in data.content_items"
        :key="idx"
        class="control"
        :class="{ 'control--active': idx === selectedTab }"
        @click="selectTab(idx)"
      >
        <SlpTypography
          tag="p"
          :variant="idx === selectedTab ? 'body1-bold' : 'body1'"
          >{{ tab.title }}</SlpTypography
        >
      </div>
    </div>

    <div
      v-for="(dropdownItem, indx) in returnSelectedTab.dropdownItems"
      :key="indx + dropdownItem.title"
      class="content-wrapper"
      :class="{
        'content-wrapper--last-item':
          indx === returnSelectedTab.dropdownItems.length - 1,
      }"
    >
      <div
        class="content-wrapper__spacer"
        :class="{ 'first-spacer': indx === 0 }"
      ></div>
      <div class="faq-container" @click="selectItem(indx)">
        <SlpTypography
          tag="h5"
          variant="heading5-bold"
          class="faq-container__title"
        >
          {{ dropdownItem.title }}
        </SlpTypography>

        <SlpIcon
          v-if="indx === selectedItem"
          class="faq-container__icon"
          name="dash"
          variant="product"
          alt="Dash Icon"
          size="lg"
        />
        <SlpIcon
          v-else
          class="faq-container__icon"
          name="plus"
          variant="product"
          alt="Plus Icon"
          size="lg"
        />
      </div>

      <transition name="fade">
        <div v-if="indx === selectedItem" class="content">
          <div class="content--image-container" @click="openModal">
            <SlpIcon
              class="content--image-container__play-icon"
              name="play-circle"
              variant="marketing"
              size="lg"
              slp-color="color-image-link-100"
            />
            <img
              class="content--image-container__image"
              :src="
                returnSelectedTab.dropdownItems[selectedItem].video.thumbnail
              "
              alt=""
            />
          </div>

          <SlpTypography class="content--text" tag="div" variant="body1">
            <span v-html="$md.render(renderText)"></span>
          </SlpTypography>
        </div>
      </transition>
    </div>
    <SolutionsVideoModal
      v-show="isModalOpen"
      :visible="isModalOpen"
      @close="isModalOpen = false"
    >
      <template #body>
        <!-- Use Embed video url -->
        <iframe
          ref="video"
          class="content--video-modal"
          :src="
            createVideoSource(
              returnSelectedTab.dropdownItems[selectedItem].video.url,
            )
          "
          title="Video player"
          allow="accelerometer; clipboard-write; encrypted-media; gyroscope; picture-in-picture"
          allowfullscreen
        ></iframe>
      </template>
    </SolutionsVideoModal>
  </section>
</template>

<style lang="scss" scoped>
.container {
  position: relative;
  max-width: 100%;
  overflow-x: clip;
  height: 100%;

  // // Full viewport background trick
  box-shadow: 0 0 0 100vw $color-surface-800;
  clip-path: inset(0 -100vw);
  background: $color-surface-800;
  margin: 48px auto;
  padding: $spacing-32 0;

  @media (min-width: $breakpoint-md) {
    padding: $spacing-96 0;
    margin: 0 auto;
  }

  &--purple-bg {
    background: $color-surface-800;
  }
  &--no-clip-path {
    clip-path: none;
  }
}

.controls {
  display: flex;
  max-width: 50vw;

  .control {
    appearance: none;
    cursor: pointer;
    padding: $spacing-24;

    &--active {
      background: $color-surface-50;
      border-top: 3px solid $color-accent-500;
    }

    p {
      text-align: center;
    }
  }
}

.faq-container {
  cursor: pointer;
  padding: $spacing-24 0;
  display: flex;
  justify-content: space-between;
  background: $color-surface-50;
  transition: all 0.3s ease-in-out;

  @media (min-width: $breakpoint-lg) {
    padding: $spacing-24 $spacing-16;
  }

  &:first-of-type {
    border-radius: $border-radius-4 $border-radius-4 0 0;
  }
  &:last-of-type {
    border-radius: 0 0 $border-radius-4 $border-radius-4;
  }

  &__icon {
    width: 24px;
    height: 24px;
    transform: rotate(180deg);
    transition: all 0.3s ease-in-out;
  }
}

.content-wrapper {
  border-radius: $border-radius-4;
  background: $color-surface-50;
  padding: 0 $spacing-16;

  @media (min-width: $breakpoint-lg) {
    padding: 0 $spacing-64;
  }

  &--last-item {
    @media (min-width: $breakpoint-lg) {
      padding: 0 $spacing-64 $spacing-48 $spacing-64;
    }
  }

  &__spacer {
    border-bottom: 1px solid $color-surface-300;
    width: 100%;

    &.first-spacer {
      padding-top: $spacing-24;

      @media (min-width: $breakpoint-lg) {
        padding-top: $spacing-48;
      }
    }
  }
}

.content {
  @media (min-width: $breakpoint-lg) {
    display: flex;
    justify-content: space-between;
    padding: $spacing-24 $spacing-16 $spacing-32 $spacing-16;
  }

  &--text {
    padding: $spacing-24 $spacing-16;

    @media (min-width: $breakpoint-lg) {
      max-width: 50%;
      padding: 0 $spacing-16;
    }

    &:deep li {
      list-style: none;
      background: url('/nuxt-images/icons/list-check-black.svg') no-repeat left
        top;
      padding-left: $spacing-32;
      padding-bottom: $spacing-16;
    }
  }

  &--image-container {
    $max_width_desktop: 418px;
    $max_width_mobile: 218px;

    cursor: pointer;
    position: relative;
    max-width: 100%;

    @media (min-width: $breakpoint-lg) {
      padding-right: $spacing-32;
      max-width: $max_width_desktop;
    }

    &__play-icon {
      position: absolute;
      top: 80px;
      left: 40vw;

      @media (min-width: $breakpoint-lg) {
        top: 90px;
        left: 160px;
      }
    }

    &__image {
      width: 100%;
      height: auto;
      object-fit: cover;
    }
  }
}

iframe,
.modal__body {
  border: none !important;
}
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.2s;
}
.fade-enter,
.fade-leave-active {
  opacity: 0;
}
</style>
